## dbusada 0.2

=== Makefile ===
PREFIX   ?= $(HOME)/libraries
TESTDIR   = tests
OBJDIR    = obj
LIBDIR    = lib
SRCDIR    = src
THINDIR   = thin
DOCDIR    = doc/html
GPR_FILES = gnat/*.gpr

PKGCONF = `pkg-config --cflags --libs dbus-glib-1`
TESTBIN = $(OBJDIR)/tests/rebounder
TESTPID = `pidof rebounder`

MAJOR   = 0
MINOR   = 2
VERSION = $(MAJOR).$(MINOR)
DBUSADA = libdbusada-$(VERSION)
TARBALL = $(DBUSADA).tar.bz2

SO_LIBRARY      = libdbusada.so.$(VERSION)
SO_LIBRARY_THIN = libdbusada-thin.so.$(VERSION)
LIBRARY_KIND    = dynamic

PREPARE := $(shell mkdir -p $(OBJDIR))

all: build_lib

build_lib:
	@gnatmake -p -Pd_bus_ada_lib -XVERSION="$(VERSION)" \
		-XLIBRARY_KIND="$(LIBRARY_KIND)"

build_tests:
	@gnatmake -p -Pd_bus_ada_tests

build_examples:
	@gnatmake -p -Pd_bus_ada_examples -XVERSION="$(VERSION)" \
		-XLIBRARY_KIND="$(LIBRARY_KIND)"

install: install_lib install_$(LIBRARY_KIND)

install_lib: build_lib
	install -d $(PREFIX)/include/dbus-ada/thin
	install -d $(PREFIX)/lib/dbus-ada/thin
	install -d $(PREFIX)/lib/gnat
	install -m 644 $(SRCDIR)/*.ad[bs] $(PREFIX)/include/dbus-ada
	install -m 644 $(THINDIR)/*.ad[bs] $(PREFIX)/include/dbus-ada/thin
	install -m 444 $(LIBDIR)/*.ali $(PREFIX)/lib/dbus-ada
	install -m 444 $(LIBDIR)/thin/*.ali $(PREFIX)/lib/dbus-ada/thin
	install -m 644 $(GPR_FILES) $(PREFIX)/lib/gnat

install_static:
	install -m 444 $(LIBDIR)/libdbusada.a $(PREFIX)/lib/dbus-ada
	install -m 444 $(LIBDIR)/thin/libdbusada-thin.a $(PREFIX)/lib/dbus-ada/thin

install_dynamic:
	install -m 444 $(LIBDIR)/$(SO_LIBRARY) $(PREFIX)/lib/dbus-ada
	install -m 444 $(LIBDIR)/thin/$(SO_LIBRARY_THIN) $(PREFIX)/lib/dbus-ada/thin
	cd $(PREFIX)/lib/dbus-ada && \
	ln -sf $(SO_LIBRARY) libdbusada.so && \
	ln -sf $(SO_LIBRARY) libdbusada.so.$(MAJOR)
	cd $(PREFIX)/lib/dbus-ada/thin && \
	ln -sf $(SO_LIBRARY_THIN) libdbusada-thin.so && \
	ln -sf $(SO_LIBRARY_THIN) libdbusada-thin.so.$(MAJOR)

tests: build_tests $(TESTBIN)
	@$(TESTBIN) &
	@$(OBJDIR)/tests/runner || true
	@kill $(TESTPID)

examples: build_examples

$(TESTBIN): $(TESTDIR)/c/dbus-rebound.c
	gcc $? $(PKGCONF) -o $@

doc:
	@$(MAKE) -C doc

clean:
	@rm -rf $(OBJDIR)
	@rm -rf $(LIBDIR)
	@rm -rf $(DOCDIR)

dist:
	@echo "Creating release tarball $(TARBALL) ... "
	@git archive --format=tar HEAD --prefix $(DBUSADA)/ | bzip2 > $(TARBALL)

.PHONY: build_examples build_lib build_tests dist doc install install_dynamic \
	install_lib install_static tests

=== debian/changelog ===
dbusada (0.2-2) unstable; urgency=low

  * Add project specific git-buildpackage configuration
  * Build dynamic/static libs in separate Obj/Lib dirs (Closes: #663672)

 -- Reto Buerki <reet@codelabs.ch>  Tue, 27 Mar 2012 14:39:21 +0200

dbusada (0.2-1) unstable; urgency=low

  * Initial release (Closes: #651159)

 -- Reto Buerki <reet@codelabs.ch>  Sun, 11 Mar 2012 21:15:11 +0100

=== debian/control ===
Source: dbusada
Section: libs
Priority: optional
Maintainer: Reto Buerki <reet@codelabs.ch>
DM-Upload-Allowed: yes
Build-Depends: asciidoc, debhelper (>= 8), gnat, gnat-4.6, libahven3-dev,
 libdbus-1-dev, libdbus-glib-1-dev, source-highlight
Standards-Version: 3.9.3
Homepage: http://www.codelabs.ch/dbus-ada/
Vcs-Browser: http://git.codelabs.ch/?p=dbus-ada.git
Vcs-Git: http://git.codelabs.ch/git/dbus-ada.git

Package: libdbusada0.2
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Ada bindings to the D-Bus message bus system
 The D_Bus/Ada library provides an Ada binding to the D-Bus message bus used for
 inter-process communication on Linux desktop systems.

Package: libdbusada0.2-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, libdbusada0.2 (= ${binary:Version}),
 libdbus-1-dev, libdbus-glib-1-dev, gnat, gnat-4.6
Description: Ada bindings to the D-Bus message bus system
 The D_Bus/Ada library provides an Ada binding to the D-Bus message bus used for
 inter-process communication on Linux desktop systems.
 .
 This package contains the development files.

Package: libdbusada0.2-dbg
Section: debug
Priority: extra
Architecture: any
Depends: ${misc:Depends}, libdbusada0.2 (= ${binary:Version}),
 libdbusada0.2-dev (= ${binary:Version})
Description: Ada bindings to the D-Bus message bus system
 The D_Bus/Ada library provides an Ada binding to the D-Bus message bus used for
 inter-process communication on Linux desktop systems.
 .
 This package contains the debugging symbols.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh ${@}

override_dh_auto_build:
	$(MAKE)
	$(MAKE) LIBRARY_KIND=static
	$(MAKE) doc

override_dh_auto_install:
	$(MAKE) PREFIX=$(CURDIR)/debian/tmp install
	$(MAKE) LIBRARY_KIND=static PREFIX=$(CURDIR)/debian/tmp install
	rm -rf debian/tmp/lib/gnat
	rm debian/tmp/lib/dbus-ada/libdbusada.so.0
	rm debian/tmp/lib/dbus-ada/thin/libdbusada-thin.so.0
	mkdir -p debian/tmp/usr/share/ada/adainclude
	cp debian/addon/*.gpr debian/tmp/usr/share/ada/adainclude

override_dh_auto_test:
	$(MAKE) tests

override_dh_install:
	dh_install --fail-missing

override_dh_compress:
	dh_compress -X.ads -X.adb -XMakefile

override_dh_strip:
	dh_strip --dbg-package=libdbusada0.2-dbg

## dbusada 0.3

=== Makefile ===
PREFIX   ?= $(HOME)/libraries
TESTDIR   = tests
OBJDIR    = obj
LIBDIR    = lib
SRCDIR    = src
THINDIR   = thin
DOCDIR    = doc/html
GPR_FILES = gnat/*.gpr

PKGCONF = `pkg-config --cflags --libs dbus-glib-1`
TESTBIN = $(OBJDIR)/tests/rebounder
TESTPID = `pidof rebounder`

MAJOR   = 0
MINOR   = 3
VERSION = $(MAJOR).$(MINOR)
DBUSADA = libdbusada-$(VERSION)
TARBALL = $(DBUSADA).tar.bz2

SO_LIBRARY   = libdbusada.so.$(VERSION)
LIBRARY_KIND = dynamic

PREPARE := $(shell mkdir -p $(OBJDIR))

all: build_lib

build_lib:
	@gnatmake -p -Pd_bus_ada_lib -XVERSION="$(VERSION)" \
		-XLIBRARY_KIND="$(LIBRARY_KIND)" -XLDFLAGS="$(LDFLAGS)" \
		-cargs $(ADAFLAGS)

build_tests:
	@gnatmake -p -Pd_bus_ada_tests

build_examples:
	@gnatmake -p -Pd_bus_ada_examples -XVERSION="$(VERSION)" \
		-XLIBRARY_KIND="$(LIBRARY_KIND)"

install: install_lib install_$(LIBRARY_KIND)

install_lib: build_lib
	install -d $(PREFIX)/include/dbus-ada
	install -d $(PREFIX)/lib/dbus-ada
	install -d $(PREFIX)/lib/gnat
	install -m 644 $(SRCDIR)/*.ad[bs] $(PREFIX)/include/dbus-ada
	install -m 644 $(THINDIR)/*.ad[bs] $(PREFIX)/include/dbus-ada
	install -m 444 $(LIBDIR)/$(LIBRARY_KIND)/*.ali $(PREFIX)/lib/dbus-ada
	install -m 644 $(GPR_FILES) $(PREFIX)/lib/gnat

install_static:
	install -m 444 $(LIBDIR)/$(LIBRARY_KIND)/libdbusada.a $(PREFIX)/lib

install_dynamic:
	install -m 444 $(LIBDIR)/$(LIBRARY_KIND)/$(SO_LIBRARY) $(PREFIX)/lib
	cd $(PREFIX)/lib && ln -sf $(SO_LIBRARY) libdbusada.so

tests: build_tests $(TESTBIN)
	@$(TESTBIN) &
	@$(OBJDIR)/tests/runner || true
	@kill $(TESTPID)

examples: build_examples

$(TESTBIN): $(TESTDIR)/c/dbus-rebound.c
	gcc $? $(PKGCONF) -o $@

doc:
	@$(MAKE) -C doc

clean:
	@rm -rf $(OBJDIR)
	@rm -rf $(LIBDIR)
	@rm -rf $(DOCDIR)

dist:
	@echo "Creating release tarball $(TARBALL) ... "
	@git archive --format=tar HEAD --prefix $(DBUSADA)/ | bzip2 > $(TARBALL)

.PHONY: doc tests

=== doc/Makefile ===
DESTDIR   ?= html
STYLEPATH ?= .
PREPARE   := $(shell mkdir -p $(DESTDIR))

ASCIIDOC_OPTS = \
	--backend=xhtml11 \
	--conf-file=page.conf \
	-a stylesdir=$(STYLEPATH) \
	-a linkcss \
	-a disable-javascript \
	-o -

all: $(DESTDIR)/asciidoc.css $(DESTDIR)/index.html

$(DESTDIR)/asciidoc.css: asciidoc.css
	cp $< $@

$(DESTDIR)/index.html: index page.conf ../README
	asciidoc $(ASCIIDOC_OPTS) $< > $@

clean:
	rm -f $(DESTDIR)/*

=== debian/changelog ===
dbusada (0.3-1ubuntu1) utopic; urgency=medium

  * Work-around --as-needed link failure.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 20 Aug 2014 21:07:18 +0200

dbusada (0.3-1) unstable; urgency=medium

  * Update gbp.conf settings
  * Set debian/compat level to 9
  * Update to release 0.3
  * Drop obsolete 'dynamic/static libs in separate dirs' patch
  * Update copyright information
  * Remove obsolete DM-Upload-Allowed from debian/control
  * Update to Standards-Version 3.9.5
  * Specify debian branch in Vcs-Git field
  * Update binary package names
  * Enable dpkg-buildflags hardening options
  * Transition to gnat-4.9 compiler (Closes: #755076)
  * Update ahven Build-Depends to libahven4-dev
  * Adjust paths in debian/*.install files
  * Remove obsolete rm calls from override_dh_auto_install
  * Decouple the aliversion from the soversion
  * Remove soversion from libdbusada-dbg package

 -- Reto Buerki <reet@codelabs.ch>  Thu, 14 Aug 2014 16:38:12 +0200

=== debian/control ===
Source: dbusada
Section: libs
Priority: optional
Maintainer: Reto Buerki <reet@codelabs.ch>
Build-Depends: asciidoc, debhelper (>= 9), gnat, gnat-4.9, libahven4-dev,
 libdbus-1-dev, libdbus-glib-1-dev, source-highlight
Standards-Version: 3.9.5
Homepage: http://www.codelabs.ch/dbus-ada/
Vcs-Browser: http://git.codelabs.ch/?p=dbus-ada.git
Vcs-Git: http://git.codelabs.ch/git/dbus-ada.git -b debian

Package: libdbusada0.3
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Ada bindings to the D-Bus message bus system
 The D_Bus/Ada library provides an Ada binding to the D-Bus message bus used for
 inter-process communication on Linux desktop systems.

Package: libdbusada1-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, libdbusada0.3 (= ${binary:Version}),
 libdbus-1-dev, libdbus-glib-1-dev, gnat, gnat-4.9
Description: Ada bindings to the D-Bus message bus system
 The D_Bus/Ada library provides an Ada binding to the D-Bus message bus used for
 inter-process communication on Linux desktop systems.
 .
 This package contains the development files.

Package: libdbusada-dbg
Section: debug
Priority: extra
Architecture: any
Depends: ${misc:Depends}, libdbusada0.3 (= ${binary:Version}),
 libdbusada1-dev (= ${binary:Version})
Description: Ada bindings to the D-Bus message bus system
 The D_Bus/Ada library provides an Ada binding to the D-Bus message bus used for
 inter-process communication on Linux desktop systems.
 .
 This package contains the debugging symbols.

=== debian/rules ===
#!/usr/bin/make -f

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

ADAFLAGS := $(filter-out -Wformat -Werror=format-security, $(CFLAGS))
export ADAFLAGS

%:
	dh ${@}

override_dh_auto_build:
	$(MAKE)
	$(MAKE) LIBRARY_KIND=static
	$(MAKE) doc

override_dh_auto_install:
	$(MAKE) PREFIX=$(CURDIR)/debian/tmp install
	$(MAKE) LIBRARY_KIND=static PREFIX=$(CURDIR)/debian/tmp install
	rm -rf debian/tmp/lib/gnat
	mkdir -p debian/tmp/usr/share/ada/adainclude
	cp debian/addon/*.gpr debian/tmp/usr/share/ada/adainclude

override_dh_auto_test:
	$(MAKE) tests

override_dh_install:
	dh_install --fail-missing

override_dh_compress:
	dh_compress -X.ads -X.adb -XMakefile

override_dh_strip:
	dh_strip --dbg-package=libdbusada-dbg

## dbusada 0.3.3

=== Makefile ===
--- 
+++ 
@@ -13,28 +13,36 @@
 
 MAJOR   = 0
 MINOR   = 3
-VERSION = $(MAJOR).$(MINOR)
+REV     = 3
+VERSION = $(MAJOR).$(MINOR).$(REV)
 DBUSADA = libdbusada-$(VERSION)
 TARBALL = $(DBUSADA).tar.bz2
 
 SO_LIBRARY   = libdbusada.so.$(VERSION)
 LIBRARY_KIND = dynamic
 
+NUM_CPUS ?= 1
+
+# GNAT_BUILDER_FLAGS, ADAFLAGS and GNATFLAGS may be overridden in the
+# environment or on the command line.
+GNAT_BUILDER_FLAGS ?= -R -j$(NUM_CPUS)
+GNATFLAGS          ?= ${GNAT_BUILDER_FLAGS} -cargs ${ADAFLAGS}
+# GMAKE_OPTS should not be overridden because -p is essential.
+GMAKE_OPTS = -p ${GNATFLAGS} -margs
+
 PREPARE := $(shell mkdir -p $(OBJDIR))
 
 all: build_lib
 
 build_lib:
-	@gnatmake -p -Pd_bus_ada_lib -XVERSION="$(VERSION)" \
-		-XLIBRARY_KIND="$(LIBRARY_KIND)" -XLDFLAGS="$(LDFLAGS)" \
-		-cargs $(ADAFLAGS)
+	gnatmake $(GMAKE_OPTS) -p -Pd_bus_ada_lib -XVERSION="$(VERSION)" \
+		-XLIBRARY_KIND="$(LIBRARY_KIND)" -XLDFLAGS="$(LDFLAGS)"
 
 build_tests:
-	@gnatmake -p -Pd_bus_ada_tests
+	gnatmake $(GMAKE_OPTS) -p -Pd_bus_ada_tests
 
 build_examples:
-	@gnatmake -p -Pd_bus_ada_examples -XVERSION="$(VERSION)" \
-		-XLIBRARY_KIND="$(LIBRARY_KIND)"
+	gnatmake $(GMAKE_OPTS) -p -Pd_bus_ada_examples
 
 install: install_lib install_$(LIBRARY_KIND)

=== debian/changelog ===
dbusada (0.3.3-1) unstable; urgency=medium

  * Update to release 0.3.3 (Closes: #758741, #795983)
  * Transition to gnat-6 compiler (Closes: #830346)
  * Drop explicit libdbusada-dbg package
  * Update binary package names
  * Switch homepage and Vcs-* URLs to HTTPS
  * Update to Standards-Version 3.9.8
  * Update local gbp.conf
  * Update ahven Build-Depends to libahven5-dev
  * Include ada/debian_packaging-6.mk in debian/rules
  * Update addon/dbus_ada.gpr file
  * Add link-with-shared autopkgtest

 -- Reto Buerki <reet@codelabs.ch>  Mon, 18 Jul 2016 10:37:00 +0200

=== debian/control ===
Source: dbusada
Section: libs
Priority: optional
Maintainer: Reto Buerki <reet@codelabs.ch>
Build-Depends: asciidoc, debhelper (>= 9), gnat, gnat-6, libahven5-dev,
 libdbus-1-dev, libdbus-glib-1-dev, source-highlight
Standards-Version: 3.9.8
Homepage: https://www.codelabs.ch/dbus-ada/
Vcs-Browser: https://git.codelabs.ch/?p=dbus-ada.git
Vcs-Git: https://git.codelabs.ch/git/dbus-ada.git -b debian

Package: libdbusada0.3.3
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Ada bindings to the D-Bus message bus system
 The D_Bus/Ada library provides an Ada binding to the D-Bus message bus used for
 inter-process communication on Linux desktop systems.

Package: libdbusada2-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, libdbusada0.3.3 (= ${binary:Version}),
 libdbus-1-dev, libdbus-glib-1-dev, gnat, gnat-6
Description: Ada bindings to the D-Bus message bus system
 The D_Bus/Ada library provides an Ada binding to the D-Bus message bus used for
 inter-process communication on Linux desktop systems.
 .
 This package contains the development files.

=== debian/rules ===
#!/usr/bin/make -f

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
include /usr/share/ada/debian_packaging-6.mk

export GNAT_BUILDER_FLAGS = $(BUILDER_OPTIONS)

%:
	dh ${@}

override_dh_auto_build:
	$(MAKE)
	$(MAKE) LIBRARY_KIND=static
	$(MAKE) doc

override_dh_auto_install:
	$(MAKE) PREFIX=$(CURDIR)/debian/tmp install
	$(MAKE) LIBRARY_KIND=static PREFIX=$(CURDIR)/debian/tmp install
	rm -rf debian/tmp/lib/gnat

override_dh_auto_test:
	$(MAKE) tests

override_dh_install:
	dh_install --fail-missing

override_dh_compress:
	dh_compress -X.ads -X.adb -XMakefile

=== debian/watch ===
version=3
http://www.codelabs.ch/download/libdbusada-(.*)\.tar\.bz2

## dbusada 0.4.0

=== Makefile ===
--- 
+++ 
@@ -12,8 +12,8 @@
 TESTPID = `pidof rebounder`
 
 MAJOR   = 0
-MINOR   = 3
-REV     = 3
+MINOR   = 4
+REV     = 0
 VERSION = $(MAJOR).$(MINOR).$(REV)
 DBUSADA = libdbusada-$(VERSION)
 TARBALL = $(DBUSADA).tar.bz2

=== doc/Makefile ===
--- 
+++ 
@@ -16,7 +16,7 @@
 	cp $< $@
 
 $(DESTDIR)/index.html: index page.conf ../README
-	asciidoc $(ASCIIDOC_OPTS) $< > $@
+	TZ=UTC asciidoc $(ASCIIDOC_OPTS) $< > $@
 
 clean:
 	rm -f $(DESTDIR)/*

=== debian/changelog ===
dbusada (0.4.0-2) unstable; urgency=medium

  [ Nicolas Boulenguez ]
  * Remove dangling references from g++ generated code. Closes: #875818.

 -- Reto Buerki <reet@codelabs.ch>  Sat, 23 Sep 2017 21:23:07 +0200

dbusada (0.4.0-1) unstable; urgency=medium

  [ Reto Buerki ]
  * Update to release 0.4.0
  * Put dh_missing in separate override_dh_missing target

  [ Nicolas Boulenguez ]
  * Watch file version 4.
  * Test: remove unused variable, display executed commands.
  * Debhelper 10. Replace deprecated --fail-missing dh_install option.
  * Standards-Version: 4.1.0.
  * Avoid hardcoded versions whenever possible.
  * Enable all hardening flags.
  * Declare phony targets.
  * Make runtime package Multi-Arch: same. Install project into right path.
  * Make short descriptions distinct.
  * Register documentation in doc-base.
  * Build with gnat-7 and libahven6-dev (Closes: #872544)
  * Refresh the thin binding.
  * Check upstream signature.
  * Clarify passing of build flags.

 -- Reto Buerki <reet@codelabs.ch>  Mon, 04 Sep 2017 09:20:29 +0200

=== debian/control ===
Source: dbusada
Section: libs
Priority: optional
Maintainer: Reto Buerki <reet@codelabs.ch>
Build-Depends: asciidoc, debhelper (>= 10),
 gnat, gnat-7,
# This line is parsed by debian/rules.
 libahven6-dev,
 pkg-config,
# To regenerate the thin binding.
 libdbus-1-dev, libdbus-glib-1-dev, source-highlight
Standards-Version: 4.1.0
Homepage: https://www.codelabs.ch/dbus-ada/
Vcs-Browser: https://git.codelabs.ch/?p=dbus-ada.git
Vcs-Git: https://git.codelabs.ch/git/dbus-ada.git -b debian

Package: libdbusada0.4.0
# This line is parsed by debian/rules.
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Ada bindings to the D-Bus message bus system (runtime)
 The D_Bus/Ada library provides an Ada binding to the D-Bus message bus used for
 inter-process communication on Linux desktop systems.

Package: libdbusada3-dev
# This line is parsed by debian/rules.
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, libdbusada0.4.0 (= ${binary:Version}),
 libdbus-1-dev, libdbus-glib-1-dev, gnat, gnat-7
Description: Ada bindings to the D-Bus message bus system
 The D_Bus/Ada library provides an Ada binding to the D-Bus message bus used for
 inter-process communication on Linux desktop systems.
 .
 This package contains the development files.

=== debian/rules ===
#!/usr/bin/make -f

$(foreach line,$(shell sed -n '\
  s/^ gnat, gnat-\([0-9.]\+\),$$/ \
    gnat_version:=\1 \
  /p;\
  s/^Package: \(libdbusada\([0-9.]\+\)\)$$/ \
    lib_pkg:=\1 \
    soversion:=\2 \
  /p;\
  s/^Package: \(libdbusada[0-9.]\+-dev\)$$/ \
    dev_pkg:=\1 \
  /p;\
  ' debian/control),$(eval $(line)))

DEB_BUILD_MAINT_OPTIONS := hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/buildflags.mk
include /usr/share/ada/debian_packaging-$(gnat_version).mk

export GNAT_BUILDER_FLAGS = $(BUILDER_OPTIONS)

%:
	dh ${@}

# Force regeneration of the thin binding included in the tarball.
.PHONY: override_dh_auto_configure
override_dh_auto_configure:
	rm -fr thin
	$(MAKE) thin CXX=g++-$(gnat_version)

.PHONY: override_dh_auto_build
override_dh_auto_build:
	$(MAKE)
	$(MAKE) LIBRARY_KIND=static
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
	$(MAKE) doc
endif

.PHONY: override_dh_auto_install
override_dh_auto_install:
	$(MAKE) PREFIX=$(CURDIR)/debian/tmp install
	$(MAKE) LIBRARY_KIND=static PREFIX=$(CURDIR)/debian/tmp install
	rm -rf debian/tmp/lib/gnat

.PHONY: override_dh_auto_test
override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	$(MAKE) tests
endif

.PHONY: override_dh_install
override_dh_install: debian/dbusada.gpr
	dh_install -p$(lib_pkg) lib/libdbusada.so.$(soversion) usr/lib/$(DEB_HOST_MULTIARCH)
	dh_install -p$(dev_pkg) lib/libdbusada.so usr/lib/$(DEB_HOST_MULTIARCH)
	dh_install -p$(dev_pkg) lib/libdbusada.a usr/lib/$(DEB_HOST_MULTIARCH)
	dh_install -p$(dev_pkg) lib/dbus-ada/*.ali usr/lib/$(DEB_HOST_MULTIARCH)/ada/adalib/dbus-ada
	dh_install -p$(dev_pkg) include/dbus-ada/*.ad[bs] usr/share/ada/adainclude/dbus-ada
	dh_install -p$(dev_pkg) debian/dbusada.gpr usr/share/gpr
	dh_install -p$(dev_pkg) debian/dbus_ada.gpr usr/share/gpr

.PHONY: override_dh_missing
override_dh_missing:
	dh_missing --fail-missing

debian/dbusada.gpr: debian/template_dbusada.gpr
	sed s/@DEB_HOST_MULTIARCH@/$(DEB_HOST_MULTIARCH)/ $< > $@

.PHONY: override_dh_clean
override_dh_clean:
	dh_clean debian/dbusada.gpr debian/$(dev_pkg).doc-base

.PHONY: override_dh_installdocs
override_dh_installdocs: debian/$(dev_pkg).doc-base
	dh_installdocs -p$(dev_pkg) doc/html/*
	dh_installdocs --remaining-packages

debian/$(dev_pkg).doc-base: debian/template_libdbusada-dev.doc-base
	sed s/@dev_pkg@/$(dev_pkg)/ $< > $@

.PHONY: override_dh_installexamples
override_dh_installexamples:
	dh_installexamples -p$(dev_pkg) examples/*
	dh_installexamples --remaining-packages

.PHONY: override_dh_compress
override_dh_compress:
	dh_compress -p$(dev_pkg) -X.ads -X.adb -XMakefile
	dh_compress --remaining-packages

=== debian/watch ===
version=4
opts=pgpsigurlmangle=s/$/.sig/ \
http://www.codelabs.ch/download/libdbusada@ANY_VERSION@@ARCHIVE_EXT@

## dbusada 0.4.2

=== Makefile ===
--- 
+++ 
@@ -13,7 +13,7 @@
 
 MAJOR   = 0
 MINOR   = 4
-REV     = 0
+REV     = 2
 VERSION = $(MAJOR).$(MINOR).$(REV)
 DBUSADA = libdbusada-$(VERSION)
 TARBALL = $(DBUSADA).tar.bz2
@@ -23,26 +23,26 @@
 
 NUM_CPUS ?= 1
 
-# GNAT_BUILDER_FLAGS, ADAFLAGS and GNATFLAGS may be overridden in the
+# GNAT_BUILDER_FLAGS, ADAFLAGS and LDFLAGS may be overridden in the
 # environment or on the command line.
 GNAT_BUILDER_FLAGS ?= -R -j$(NUM_CPUS)
-GNATFLAGS          ?= ${GNAT_BUILDER_FLAGS} -cargs ${ADAFLAGS}
+
 # GMAKE_OPTS should not be overridden because -p is essential.
-GMAKE_OPTS = -p ${GNATFLAGS} -margs
+GMAKE_OPTS = -p ${GNAT_BUILDER_FLAGS} \
+  $(foreach v,ADAFLAGS LDFLAGS VERSION,"-X$(v)=$($(v))")
 
 PREPARE := $(shell mkdir -p $(OBJDIR))
 
 all: build_lib
 
 build_lib:
-	gnatmake $(GMAKE_OPTS) -p -Pd_bus_ada_lib -XVERSION="$(VERSION)" \
-		-XLIBRARY_KIND="$(LIBRARY_KIND)" -XLDFLAGS="$(LDFLAGS)"
+	gprbuild $(GMAKE_OPTS) -Pd_bus_ada_lib -XLIBRARY_KIND=$(LIBRARY_KIND)
 
 build_tests:
-	gnatmake $(GMAKE_OPTS) -p -Pd_bus_ada_tests
+	gprbuild $(GMAKE_OPTS) -Pd_bus_ada_tests -XLIBRARY_KIND=static
 
 build_examples:
-	gnatmake $(GMAKE_OPTS) -p -Pd_bus_ada_examples
+	gprbuild $(GMAKE_OPTS) -Pd_bus_ada_examples -XLIBRARY_KIND=static
 
 install: install_lib install_$(LIBRARY_KIND)
 
@@ -56,10 +56,10 @@
 	install -m 644 $(GPR_FILES) $(PREFIX)/lib/gnat
 
 install_static:
-	install -m 444 $(LIBDIR)/$(LIBRARY_KIND)/libdbusada.a $(PREFIX)/lib
+	install -m 644 $(LIBDIR)/$(LIBRARY_KIND)/libdbusada.a $(PREFIX)/lib
 
 install_dynamic:
-	install -m 444 $(LIBDIR)/$(LIBRARY_KIND)/$(SO_LIBRARY) $(PREFIX)/lib
+	install -m 644 $(LIBDIR)/$(LIBRARY_KIND)/$(SO_LIBRARY) $(PREFIX)/lib
 	cd $(PREFIX)/lib && ln -sf $(SO_LIBRARY) libdbusada.so
 
 tests: build_tests $(TESTBIN)

=== debian/changelog ===
dbusada (0.4.2-3) unstable; urgency=medium

  * Rebuild in unstable for gnat-8 transition. Closes: #897736.

 -- Nicolas Boulenguez <nicolas@debian.org>  Sat, 27 Oct 2018 15:09:42 +0200

dbusada (0.4.2-2) experimental; urgency=medium

  * Restore a paragraph removed by error from the thin binding generator
    when switching to g++-8, but still necessary on most architectures.

 -- Nicolas Boulenguez <nicolas@debian.org>  Wed, 12 Sep 2018 19:42:56 +0200

dbusada (0.4.2-1) experimental; urgency=medium

  [ Reto Buerki ]
  * Update copyright (Closes: #905818)
  * Update to release 0.4.2

  [ Nicolas Boulenguez ]
  * Simplify the packaging with dh-ada-library.
  * Regenerate the thin binding (to ensure that the end user can rebuild)
    but with g++-8 (independently of the current default C++ compiler).
  * Standards-Version: 4.2.1. No changes.
  * Give each binary package a distinct description.
  * Set as-needed and no-undefined linker options explicitly.
  * Pass a consistent set of flags to each Make, show them in the log.
  * Use dh_auto_* options instead of raw make (for example, -j).

 -- Nicolas Boulenguez <nicolas@debian.org>  Tue, 04 Sep 2018 10:11:55 +0200

dbusada (0.4.1-1) experimental; urgency=medium

  [ Nicolas Boulenguez ]
  * Remove source/local-options
  * Debhelper 11 (no changes)
  * Standards-Version: 4.1.5. Rules-Requires-Root: no
  * Explicitly mark template_dbusada.gpr as library project
  * Update copyright
  * Add Nicolas as uploader
  * Rebuild with gnat-8. Bump ALI and SO version

  [ Reto Buerki ]
  * Update to release 0.4.1
  * Do not refresh thin binding
  * Switch to https in debian/watch

 -- Reto Buerki <reet@codelabs.ch>  Thu, 09 Aug 2018 13:54:05 +0200

=== debian/control ===
Source: dbusada
Section: libs
Priority: optional
Maintainer: Reto Buerki <reet@codelabs.ch>
Uploaders: Nicolas Boulenguez <nicolas@debian.org>
Build-Depends:
 asciidoc,
 debhelper (>= 11),
 dh-ada-library,
 g++-8,
# scripts/generate-thin-binding.sh
 gnat, gnat-8,
# This line is parsed by debian/rules.
 gprbuild,
 libahven7-dev,
 pkg-config,
# To regenerate the thin binding.
 libdbus-1-dev, libdbus-glib-1-dev, source-highlight
Standards-Version: 4.2.1
Rules-Requires-Root: no
Homepage: https://www.codelabs.ch/dbus-ada/
Vcs-Browser: https://git.codelabs.ch/?p=dbus-ada.git
Vcs-Git: https://git.codelabs.ch/git/dbus-ada.git -b debian

Package: libdbusada0.4.1
# This line is parsed by debian/rules.
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Ada bindings to the D-Bus message bus system (runtime)
 The D_Bus/Ada library provides an Ada binding to the D-Bus message bus used for
 inter-process communication on Linux desktop systems.
 .
 This package contains the shared library.

Package: libdbusada4-dev
# This line is parsed by debian/rules.
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, ${ada:Depends},
 libdbus-1-dev,
 libdbus-glib-1-dev,
Description: Ada bindings to the D-Bus message bus system
 The D_Bus/Ada library provides an Ada binding to the D-Bus message bus used for
 inter-process communication on Linux desktop systems.
 .
 This package contains the development files.

=== debian/rules ===
#!/usr/bin/make -f

$(foreach line,$(shell sed -n '\
  s/^ gnat, gnat-\([0-9.]\+\),$$/ \
    gnat_version:=\1 \
  /p;\
  s/^Package: libdbusada\([0-9.]\+\)$$/ \
    VERSION:=\1 \
  /p;\
  s/^Package: \(libdbusada[0-9.]\+-dev\)$$/ \
    dev_pkg:=\1 \
  /p;\
  ' debian/control),$(eval $(line)))

DEB_BUILD_MAINT_OPTIONS := hardening=+all
DEB_LDFLAGS_MAINT_APPEND := -Wl,--as-needed -Wl,--no-undefined
include /usr/share/dpkg/buildflags.mk
include /usr/share/ada/debian_packaging-$(gnat_version).mk

make_vars := \
  GNAT_BUILDER_FLAGS='$(BUILDER_OPTIONS)' \
  $(foreach v,ADAFLAGS LDFLAGS VERSION,$(v)='$($(v))')

%:
	dh $@ --with ada-library

.PHONY: override_dh_auto_build
override_dh_auto_build:
	if [ ! -e thin.bak ]; then \
	  mv thin thin.bak && \
	  sh scripts/generate-thin-binding.sh; \
	fi
	dh_auto_build -- $(make_vars)
	dh_auto_build -- LIBRARY_KIND=static $(make_vars)
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
	dh_auto_build -- doc $(make_vars)
endif

.PHONY: override_dh_auto_test
override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	$(MAKE) tests $(make_vars)
endif

.PHONY: override_dh_auto_install
# Empty.

.PHONY: override_dh_install
override_dh_install:
	dh_install -p$(dev_pkg) debian/dbus_ada.gpr usr/share/gpr
	dh_install --remaining-packages

.PHONY: override_dh_clean
override_dh_clean:
	dh_clean debian/$(dev_pkg).doc-base
	if [ -e thin.bak ]; then \
	  rm -r thin && \
	  mv thin.bak thin; \
	fi

.PHONY: override_dh_installdocs
override_dh_installdocs: debian/$(dev_pkg).doc-base
	dh_installdocs -p$(dev_pkg) doc/html/*
	dh_installdocs --remaining-packages

debian/$(dev_pkg).doc-base: debian/template_libdbusada-dev.doc-base
	sed s/@dev_pkg@/$(dev_pkg)/ $< > $@

.PHONY: override_dh_installexamples
override_dh_installexamples:
	dh_installexamples -p$(dev_pkg) examples/*
	dh_installexamples --remaining-packages

.PHONY: override_dh_compress
override_dh_compress:
	dh_compress -p$(dev_pkg) -X.ads -X.adb -XMakefile
	dh_compress --remaining-packages

## dbusada 0.5.0

=== Makefile ===
--- 
+++ 
@@ -12,8 +12,8 @@
 TESTPID = `pidof rebounder`
 
 MAJOR   = 0
-MINOR   = 4
-REV     = 2
+MINOR   = 5
+REV     = 0
 VERSION = $(MAJOR).$(MINOR).$(REV)
 DBUSADA = libdbusada-$(VERSION)
 TARBALL = $(DBUSADA).tar.bz2

=== doc/Makefile ===
DESTDIR ?= html
PREPARE := $(shell mkdir -p $(DESTDIR))

ASCIIDOC_OPTS = \
	-a icons=font \
	-a iconfont-remote! \
	-a stylesdir=css \
	-a stylesheet=styles.css \
	-a sectanchors \
	-o -

all: $(DESTDIR)/index.html

$(DESTDIR)/index.html: $(DESTDIR)/fonts $(DESTDIR)/css/font-awesome.css
$(DESTDIR)/index.html: index ../README css/styles.css
	TZ=UTC asciidoctor $(ASCIIDOC_OPTS) $< > $@

$(DESTDIR)/css/font-awesome.css: css/font-awesome.css
	mkdir -p $(DESTDIR)/css
	cp $< $@

$(DESTDIR)/fonts: fonts
	mkdir -p $(DESTDIR)
	cp -R $< $@

clean:
	rm -rf $(DESTDIR)

=== debian/changelog ===
dbusada (0.5.0-4) unstable; urgency=medium

  [ Nicolas Boulenguez ]
  * Swap binary packages in control files
  * Standards-Version: 4.5.0

  [ Reto Buerki ]
  * Add patch to create $(OBJDIR)/tests. Closes: ##955976

 -- Reto Buerki <reet@codelabs.ch>  Wed, 08 Apr 2020 13:10:23 +0200

dbusada (0.5.0-3) unstable; urgency=medium

  * Reupload to unstable for gnat-9 transition.

 -- Nicolas Boulenguez <nicolas@debian.org>  Tue, 25 Feb 2020 13:49:12 +0100

dbusada (0.5.0-2) experimental; urgency=medium

  * Restore a paragraph removed from the thin binding generator when switching
    to g++-9, but still necessary on most architectures (see 0.4.2-2).
  * Use less redundant dh-sequence-* syntax for dh-ada-library.

 -- Nicolas Boulenguez <nicolas@debian.org>  Mon, 30 Dec 2019 22:18:02 +0100

dbusada (0.5.0-1) experimental; urgency=medium

  * New upstream release, built with gcc-9. Closes: #944183.
    Rename lib and -dev package accordingly.
  * Repackage without fonts.
  * Debhelper 12 does not compress examples anymore.
  * Documentation is now generated with asciidoctor.
  * Standards-Version: 4.4.1.
  * Enable all linker warnings.
  * Update AUTOPKGTEST_TMP variable name.
  * Update upstream signing key.

 -- Nicolas Boulenguez <nicolas@debian.org>  Sat, 16 Nov 2019 20:31:48 +0100

=== debian/control ===
Source: dbusada
Section: libs
Priority: optional
Maintainer: Reto Buerki <reet@codelabs.ch>
Uploaders: Nicolas Boulenguez <nicolas@debian.org>
Build-Depends:
 asciidoctor,
 debhelper-compat (= 12),
 dh-sequence-ada-library,
 g++-9,
# scripts/generate-thin-binding.sh
 gnat, gnat-9,
# This line is parsed by debian/rules.
 gprbuild,
 libahven8-dev,
 libdbus-1-dev,
 libdbus-glib-1-dev,
 pkg-config,
 ruby-pygments.rb,
Standards-Version: 4.5.0
Rules-Requires-Root: no
Homepage: https://www.codelabs.ch/dbus-ada/
Vcs-Browser: https://git.codelabs.ch/?p=dbus-ada.git
Vcs-Git: https://git.codelabs.ch/git/dbus-ada.git -b debian

Package: libdbusada5-dev
# This line is parsed by debian/rules.
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, ${ada:Depends},
 libdbus-1-dev,
 libdbus-glib-1-dev,
Description: Ada bindings to the D-Bus message bus system
 The D_Bus/Ada library provides an Ada binding to the D-Bus message bus used for
 inter-process communication on Linux desktop systems.
 .
 This package contains the development files.

Package: libdbusada0.5.0
# This line is parsed by debian/rules.
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Ada bindings to the D-Bus message bus system (runtime)
 The D_Bus/Ada library provides an Ada binding to the D-Bus message bus used for
 inter-process communication on Linux desktop systems.
 .
 This package contains the shared library.

=== debian/rules ===
#!/usr/bin/make -f

$(foreach line,$(shell sed -n '\
  s/^ gnat, gnat-\([0-9.]\+\),$$/ \
    gnat_version:=\1 \
  /p;\
  s/^Package: libdbusada\([0-9.]\+\)$$/ \
    VERSION:=\1 \
  /p;\
  s/^Package: \(libdbusada[0-9.]\+-dev\)$$/ \
    dev_pkg:=\1 \
  /p;\
  ' debian/control),$(eval $(line)))

DEB_BUILD_MAINT_OPTIONS := hardening=+all
DEB_LDFLAGS_MAINT_APPEND := -Wl,--no-undefined \
  -Wl,--no-copy-dt-needed-entries -Wl,--no-allow-shlib-undefined
include /usr/share/dpkg/buildflags.mk
include /usr/share/ada/debian_packaging-$(gnat_version).mk

make_vars := \
  GNAT_BUILDER_FLAGS='$(BUILDER_OPTIONS)' \
  $(foreach v,ADAFLAGS LDFLAGS VERSION,$(v)='$($(v))')

%:
	dh $@

.PHONY: override_dh_auto_build
override_dh_auto_build:
	if [ ! -e thin.bak ]; then \
	  mv thin thin.bak && \
	  sh scripts/generate-thin-binding.sh; \
	fi
	dh_auto_build -- $(make_vars)
	dh_auto_build -- LIBRARY_KIND=static $(make_vars)
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
	dh_auto_build -- doc $(make_vars)
endif

.PHONY: override_dh_auto_test
override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	$(MAKE) tests $(make_vars)
endif

.PHONY: override_dh_auto_install
# Empty.

.PHONY: override_dh_clean
override_dh_clean:
	dh_clean debian/$(dev_pkg).doc-base
	if [ -e thin.bak ]; then \
	  rm -r thin && \
	  mv thin.bak thin; \
	fi

override_dh_auto_build: debian/$(dev_pkg).doc-base
debian/$(dev_pkg).doc-base: debian/template_libdbusada-dev.doc-base
	sed s/@dev_pkg@/$(dev_pkg)/ $< > $@

## dbusada 0.6.0

=== Makefile ===
--- 
+++ 
@@ -12,7 +12,7 @@
 TESTPID = `pidof rebounder`
 
 MAJOR   = 0
-MINOR   = 5
+MINOR   = 6
 REV     = 0
 VERSION = $(MAJOR).$(MINOR).$(REV)
 DBUSADA = libdbusada-$(VERSION)
@@ -69,7 +69,10 @@
 
 examples: build_examples
 
-$(TESTBIN): $(TESTDIR)/c/dbus-rebound.c
+$(OBJDIR)/tests:
+	@mkdir -p $@
+
+$(TESTBIN): $(TESTDIR)/c/dbus-rebound.c | $(OBJDIR)/tests
 	gcc $? $(PKGCONF) -o $@
 
 doc:

=== doc/Makefile ===
DESTDIR ?= html

all: $(DESTDIR)/index.html

$(DESTDIR)/index.html: $(DESTDIR)/fonts
$(DESTDIR)/index.html: index ../README css/styles.css | $(DESTDIR)
	asciidoctor $< -o $@

$(DESTDIR)/fonts: fonts | $(DESTDIR)
	cp -R $< $@

$(DESTDIR):
	mkdir $(DESTDIR)

clean:
	rm -rf $(DESTDIR)

=== debian/changelog ===
dbusada (0.6.0-5) unstable; urgency=medium

  * Reupload to unstable for the gnat-11 transition.
  * Require dh-ada-library 7.5, which generates ada:Depends differently

 -- Nicolas Boulenguez <nicolas@debian.org>  Mon, 09 May 2022 10:46:57 +0200

dbusada (0.6.0-4) experimental; urgency=medium

  * Build with gcc-11 for experimental. Rename -dev package accordingly.
  * Use unversioned debian_packaging.mk from gnat package.
  * Standards-Version: 4.6.0 (no changes).
  * Remove arch or version dependent paths from comments (hopefully
    reducing the noise in future diffs).
  * Use build flags when building tests/rebounder.

 -- Nicolas Boulenguez <nicolas@debian.org>  Thu, 31 Mar 2022 20:07:38 +0000

dbusada (0.6.0-3) unstable; urgency=medium

  * Reupload to unstable for gnat- transition.
  * Standards-Version: 4.5.1.

 -- Nicolas Boulenguez <nicolas@debian.org>  Sat, 19 Dec 2020 14:39:28 +0100

dbusada (0.6.0-2) experimental; urgency=medium

  * Add patch to strip stdarg_h.Class_va_list again

 -- Reto Buerki <reet@codelabs.ch>  Tue, 17 Nov 2020 09:04:07 +0100

dbusada (0.6.0-1) experimental; urgency=medium

  [ Nicolas Boulenguez ]
  * Remove the thin binding from repackaged upstream tarball
  * Debhelper 13
  * Transmit build flags via the environment
  * Remove some references to aliversion from doc-base
  * Remove applied patches
  * Build with gcc-10
  * Delegate C dependencies to dh-ada-library
  * Update copyright

  [ Reto Buerki ]
  * Remove font-awesome.css from Files-Excluded
  * Update to repackaged upstream 0.6.0
  * Add patch to disable message dispatcher tests

 -- Reto Buerki <reet@codelabs.ch>  Fri, 23 Oct 2020 09:52:47 +0200

=== debian/control ===
--- 
+++ 
@@ -5,38 +5,37 @@
 Uploaders: Nicolas Boulenguez <nicolas@debian.org>
 Build-Depends:
  asciidoctor,
- debhelper-compat (= 12),
+ debhelper-compat (= 13),
+ dh-ada-library (>= 7.5),
  dh-sequence-ada-library,
- g++-9,
+ g++-11,
 # scripts/generate-thin-binding.sh
- gnat, gnat-9,
-# This line is parsed by debian/rules.
+ gnat,
+ gnat-11,
  gprbuild,
- libahven8-dev,
+ libahven10-dev,
  libdbus-1-dev,
  libdbus-glib-1-dev,
  pkg-config,
  ruby-pygments.rb,
-Standards-Version: 4.5.0
+Standards-Version: 4.6.0
 Rules-Requires-Root: no
 Homepage: https://www.codelabs.ch/dbus-ada/
 Vcs-Browser: https://git.codelabs.ch/?p=dbus-ada.git
 Vcs-Git: https://git.codelabs.ch/git/dbus-ada.git -b debian
 
-Package: libdbusada5-dev
+Package: libdbusada7-dev
 # This line is parsed by debian/rules.
 Section: libdevel
 Architecture: any
 Depends: ${misc:Depends}, ${ada:Depends},
- libdbus-1-dev,
- libdbus-glib-1-dev,
 Description: Ada bindings to the D-Bus message bus system
  The D_Bus/Ada library provides an Ada binding to the D-Bus message bus used for
  inter-process communication on Linux desktop systems.
  .
  This package contains the development files.
 
-Package: libdbusada0.5.0
+Package: libdbusada0.6.0
 # This line is parsed by debian/rules.
 Architecture: any
 Multi-Arch: same

=== debian/rules ===
#!/usr/bin/make -f

$(foreach line,$(shell sed -n '\
  s/^Package: libdbusada\([0-9.]\+\)$$/ \
    VERSION:=\1 \
  /p;\
  s/^Package: \(libdbusada[0-9.]\+-dev\)$$/ \
    dev_pkg:=\1 \
  /p;\
  ' debian/control),$(eval $(line)))

DPKG_EXPORT_BUILDFLAGS := 1
DEB_BUILD_MAINT_OPTIONS := hardening=+all
DEB_LDFLAGS_MAINT_APPEND := -Wl,--no-undefined \
  -Wl,--no-copy-dt-needed-entries -Wl,--no-allow-shlib-undefined
include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/buildopts.mk
include /usr/share/ada/debian_packaging.mk

make_vars := \
  GNAT_BUILDER_FLAGS='$(GPRBUILDFLAGS)' \
  VERSION=$(VERSION)

%:
	dh $@

.PHONY: override_dh_auto_build
override_dh_auto_build:
	dh_auto_build -- $(make_vars)
	dh_auto_build -- LIBRARY_KIND=static $(make_vars)
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
	dh_auto_build -- doc $(make_vars)
endif

override_dh_auto_build: thin
thin:
	sh scripts/generate-thin-binding.sh

.PHONY: override_dh_auto_test
override_dh_auto_test:
	$(MAKE) tests $(make_vars)

.PHONY: override_dh_auto_install
# Empty.

# d/doc-base affects -dev, the first package in d/control
override_dh_auto_build: debian/doc-base
debian/doc-base: debian/template_libdbusada-dev.doc-base
	sed s/@dev_pkg@/$(dev_pkg)/ $< > $@

## dbusada 0.6.2

=== Makefile ===
PREFIX   ?= $(HOME)/libraries
TESTDIR   = tests
OBJDIR    = obj
LIBDIR    = lib

PKGCONF = `pkg-config --cflags --libs dbus-glib-1`
TESTBIN = $(OBJDIR)/tests/rebounder
TESTPID = `pidof rebounder`

MAJOR   = 0
MINOR   = 6
REV     = 2
VERSION = $(MAJOR).$(MINOR).$(REV)
# Set VERSION to '' for a static library.
DBUSADA = libdbusada-$(VERSION)
TARBALL = $(DBUSADA).tar.bz2

NUM_CPUS ?= 1

# GNAT_BUILDER_FLAGS, ADAFLAGS and LDFLAGS may be overridden in the
# environment or on the command line.
GNAT_BUILDER_FLAGS ?= -R -j$(NUM_CPUS)

# GMAKE_OPTS should not be overridden because -p is essential.
GMAKE_OPTS = -p ${GNAT_BUILDER_FLAGS} \
  $(foreach v,ADAFLAGS LDFLAGS,"-X$(v)=$($(v))")

# This variable explicitly exists for override by people with a
# different directory hierarchy.
# exec is unrelated and currently only used by tests
GPRINSTALLFLAGS := \
  --prefix=$(PREFIX) \
  --no-manifest \
  --exec-subdir=tests \
  --ali-subdir=lib/dbus-ada \
  --lib-subdir=lib \
  --project-subdir=lib/gnat \
  --sources-subdir=include/dbus-ada \
  # EOL

all: build-lib

build-lib:
	gprbuild $(GMAKE_OPTS) -Pdbusada -XVERSION=$(VERSION)

build-tests:
	gprbuild $(GMAKE_OPTS) -Pd_bus_ada_tests -XVERSION=

build-examples:
	gprbuild $(GMAKE_OPTS) -Pd_bus_ada_examples -XVERSION=

install: build-lib
	gprinstall -f -p -Pdbusada -XVERSION=$(VERSION) $(GPRINSTALLFLAGS)

tests: build-tests $(TESTBIN)
	@$(TESTBIN) &
	@$(OBJDIR)/tests/runner || true
	@kill $(TESTPID)

$(OBJDIR)/tests:
	@mkdir -p $@

$(TESTBIN): $(TESTDIR)/c/dbus-rebound.c | $(OBJDIR)/tests
	$(CC) $(CPPFLAGS) $(CFLAGS) -o $@ $^ $(PKGCONF) $(LDLIBS)

clean:
	@rm -rf $(OBJDIR)
	@rm -rf $(LIBDIR)

dist:
	@echo "Creating release tarball $(TARBALL) ... "
	@git archive --format=tar HEAD --prefix $(DBUSADA)/ | bzip2 > $(TARBALL)

.PHONY: tests

include doc/doc.mk

=== debian/changelog ===
dbusada (0.6.2-4) unstable; urgency=medium

  * Break/Replace libdbusada*-dev since oldstable. Closes: #1034914.

 -- Nicolas Boulenguez <nicolas@debian.org>  Thu, 11 May 2023 11:34:08 +0200

dbusada (0.6.2-3) unstable; urgency=medium

  * Let -dev depend on libdbus*-dev (previously done by dh-ada-library).

 -- Nicolas Boulenguez <nicolas@debian.org>  Fri, 30 Dec 2022 18:33:03 +0000

dbusada (0.6.2-2) unstable; urgency=medium

  * Reupload to unstable for the gnat-12 transition.
  * Standards-Version: 4.6.2 (no changes).

 -- Nicolas Boulenguez <nicolas@debian.org>  Tue, 27 Dec 2022 02:15:28 +0100

dbusada (0.6.2-1) experimental; urgency=medium

  * Build with gnat/12 and dh-ada-library/8.2 for experimental.
    Rename -dev package accordingly.
  * New upstream version.
  * Standards-Version: 4.6.1
  * Stop build-depending on unversioned gnat
  * Update copyright years
  * Add upstream metadata
  * Stop repackaging, embed fonts, refresh binding
  * Revert dh_auto_build to Make
  * Install: prefer an explicit package for installation of the project

 -- Nicolas Boulenguez <nicolas@debian.org>  Sat, 26 Nov 2022 18:59:10 +0100

=== debian/control ===
--- 
+++ 
@@ -6,29 +6,31 @@
 Build-Depends:
  asciidoctor,
  debhelper-compat (= 13),
- dh-ada-library (>= 7.5),
+ dh-ada-library (>= 8.2),
  dh-sequence-ada-library,
- g++-11,
+ g++-12,
 # scripts/generate-thin-binding.sh
- gnat,
- gnat-11,
+ gnat-12,
  gprbuild,
- libahven10-dev,
+ libahven11-dev,
  libdbus-1-dev,
  libdbus-glib-1-dev,
  pkg-config,
  ruby-pygments.rb,
-Standards-Version: 4.6.0
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Homepage: https://www.codelabs.ch/dbus-ada/
 Vcs-Browser: https://git.codelabs.ch/?p=dbus-ada.git
 Vcs-Git: https://git.codelabs.ch/git/dbus-ada.git -b debian
 
-Package: libdbusada7-dev
-# This line is parsed by debian/rules.
+Package: libdbusada8-dev
+Breaks: libdbusada4-dev, libdbusada5-dev, libdbusada6-dev, libdbusada7-dev
+Replaces: libdbusada4-dev, libdbusada5-dev, libdbusada6-dev, libdbusada7-dev
 Section: libdevel
 Architecture: any
 Depends: ${misc:Depends}, ${ada:Depends},
+ libdbus-1-dev,
+ libdbus-glib-1-dev,
 Description: Ada bindings to the D-Bus message bus system
  The D_Bus/Ada library provides an Ada binding to the D-Bus message bus used for
  inter-process communication on Linux desktop systems.
@@ -36,7 +38,6 @@
  This package contains the development files.
 
 Package: libdbusada0.6.0
-# This line is parsed by debian/rules.
 Architecture: any
 Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends}

=== debian/rules ===
#!/usr/bin/make -f

DPKG_EXPORT_BUILDFLAGS := 1
DEB_BUILD_MAINT_OPTIONS := hardening=+all
DEB_LDFLAGS_MAINT_APPEND := -Wl,--no-undefined \
  -Wl,--no-copy-dt-needed-entries -Wl,--no-allow-shlib-undefined
include /usr/share/dpkg/buildflags.mk
include /usr/share/ada/packaging.mk

make_vars := \
  GNAT_BUILDER_FLAGS='$(GPRBUILDFLAGS)'

%:
	dh $@

.PHONY: override_dh_auto_build
override_dh_auto_build:
	$(MAKE) $(make_vars) VERSION=$(dbusada_SO_VERSION)
	$(MAKE) $(make_vars) VERSION=
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
	$(MAKE) build-doc $(make_vars)
endif

override_dh_auto_build: thin-stamp
thin-stamp:
	rm -fr thin
	sh scripts/generate-thin-binding.sh g++-$(DEB_GNAT_VERSION)
	touch $@

.PHONY: override_dh_auto_test
override_dh_auto_test:
	$(MAKE) tests $(make_vars)

.PHONY: override_dh_auto_install
override_dh_auto_install:
	$(MAKE) install $(make_vars) VERSION= \
	  GPRINSTALLFLAGS='$(static_GPRINSTALLFLAGS)'
	$(MAKE) install $(make_vars) VERSION=$(dbusada_SO_VERSION) \
	  GPRINSTALLFLAGS='$(call shared_GPRINSTALLFLAGS,dbusada)'

# d/doc-base affects -dev, the first package in d/control
override_dh_auto_build: debian/doc-base
debian/doc-base: debian/template_libdbusada-dev.doc-base
	sed s/@dev_pkg@/$(dbusada_DEV_PKG)/ $< > $@

execute_after_dh_install:
	dh_install --package=$(dbusada_DEV_PKG) \
	  debian/dbusada.gpr $(DEB_GNAT_PROJECT_DIR)

## dbusada 0.6.3

=== Makefile ===
--- 
+++ 
@@ -9,7 +9,7 @@
 
 MAJOR   = 0
 MINOR   = 6
-REV     = 2
+REV     = 3
 VERSION = $(MAJOR).$(MINOR).$(REV)
 # Set VERSION to '' for a static library.
 DBUSADA = libdbusada-$(VERSION)

=== debian/changelog ===
dbusada (0.6.3-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Add upstream fix for FTBFS with GCC 15. (Closes: #1096509)

 -- Adrian Bunk <bunk@debian.org>  Mon, 22 Sep 2025 13:29:06 +0300

dbusada (0.6.3-2) unstable; urgency=medium

  * Reupload to unstable for the gnat-14 transition.  Closes: #1100460.

 -- Nicolas Boulenguez <nicolas@debian.org>  Wed, 19 Mar 2025 15:56:29 +0100

dbusada (0.6.3-1) experimental; urgency=medium

  * New upstream release
  * Build with gnat-14
  * Mark Disable-message-dispatcher-tests.patch as Forwarded: not-needed
  * Apply build flags during C translation and tests
  * Update copyright years
  * Bump Standards-Version (no changes)

 -- Nicolas Boulenguez <nicolas@debian.org>  Thu, 02 Jan 2025 00:05:02 +0100

dbusada (0.6.2-6) unstable; urgency=medium

  * Reupload to unstable for the gnat-13/time_t64 transition.
  * Build-Depend on pkgconf instead of deprecated pkg-config.

 -- Nicolas Boulenguez <nicolas@debian.org>  Sun, 17 Mar 2024 19:15:56 +0000

dbusada (0.6.2-5) experimental; urgency=medium

  * Upload to experimental because of the following transitions.
  * Build with gnat-13.  Rename library package with new SOversion.
  * Build with dh-ada-library/9. Remove version from -dev package name.
    Provide a name containing a hash.
    Build-Depend: gnat in addition to gnat-13. Break/Replace previous -devs.
  * Use explicit debian/PACKAGE.{doc-base,docs,examples} files and test
    dependencies now that the -dev package is unversioned.
  * Stop providing the gnat project under two names.
  * Apply 944e0909: containers: add missing constant keyword.
  * Prevent recompilation by test and install targets.

 -- Nicolas Boulenguez <nicolas@debian.org>  Mon, 01 Jan 2024 16:28:50 +0000

=== debian/control ===
--- 
+++ 
@@ -6,26 +6,29 @@
 Build-Depends:
  asciidoctor,
  debhelper-compat (= 13),
- dh-ada-library (>= 8.2),
+ dh-ada-library (>= 9.1),
  dh-sequence-ada-library,
- g++-12,
-# scripts/generate-thin-binding.sh
- gnat-12,
- gprbuild,
- libahven11-dev,
+ g++-14,
+ gnat,
+ gnat-14,
+ gprbuild (>= 2025.0.0-2),
+ libahven-dev,
  libdbus-1-dev,
  libdbus-glib-1-dev,
- pkg-config,
+ pkgconf,
  ruby-pygments.rb,
-Standards-Version: 4.6.2
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Homepage: https://www.codelabs.ch/dbus-ada/
 Vcs-Browser: https://git.codelabs.ch/?p=dbus-ada.git
 Vcs-Git: https://git.codelabs.ch/git/dbus-ada.git -b debian
 
-Package: libdbusada8-dev
-Breaks: libdbusada4-dev, libdbusada5-dev, libdbusada6-dev, libdbusada7-dev
-Replaces: libdbusada4-dev, libdbusada5-dev, libdbusada6-dev, libdbusada7-dev
+Package: libdbusada-dev
+Breaks: libdbusada4-dev, libdbusada5-dev, libdbusada6-dev, libdbusada7-dev,
+ libdbusada8-dev
+Replaces: libdbusada4-dev, libdbusada5-dev, libdbusada6-dev, libdbusada7-dev,
+ libdbusada8-dev
+Provides: ${ada:Provides}
 Section: libdevel
 Architecture: any
 Depends: ${misc:Depends}, ${ada:Depends},
@@ -37,7 +40,7 @@
  .
  This package contains the development files.
 
-Package: libdbusada0.6.0
+Package: libdbusada0.6.1
 Architecture: any
 Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends}

=== debian/rules ===
--- 
+++ 
@@ -7,8 +7,9 @@
 include /usr/share/dpkg/buildflags.mk
 include /usr/share/ada/packaging.mk
 
+# -m prevents a rebuild of the thin binding for examples and installation
 make_vars := \
-  GNAT_BUILDER_FLAGS='$(GPRBUILDFLAGS)'
+  GNAT_BUILDER_FLAGS='$(GPRBUILDFLAGS) -m'
 
 %:
 	dh $@
@@ -37,12 +38,3 @@
 	  GPRINSTALLFLAGS='$(static_GPRINSTALLFLAGS)'
 	$(MAKE) install $(make_vars) VERSION=$(dbusada_SO_VERSION) \
 	  GPRINSTALLFLAGS='$(call shared_GPRINSTALLFLAGS,dbusada)'
-
-# d/doc-base affects -dev, the first package in d/control
-override_dh_auto_build: debian/doc-base
-debian/doc-base: debian/template_libdbusada-dev.doc-base
-	sed s/@dev_pkg@/$(dbusada_DEV_PKG)/ $< > $@
-
-execute_after_dh_install:
-	dh_install --package=$(dbusada_DEV_PKG) \
-	  debian/dbusada.gpr $(DEB_GNAT_PROJECT_DIR)

=== debian/watch ===
version=4
opts=pgpsigurlmangle=s/$/.sig/ \
https://www.codelabs.ch/download/libdbusada@ANY_VERSION@@ARCHIVE_EXT@
